apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "bbbAtScale.fullname" . }}-webhooks-worker
  labels:
    {{- include "bbbAtScale.labels" . | nindent 4 }}
  annotations:
    image.openshift.io/triggers: '[{"from":{"kind":"ImageStreamTag","name":"{{ include "bbbAtScale.fullname" . }}:live"},"fieldPath":"spec.template.spec.containers[?(@.name==\"{{ .Chart.Name }}\")].image"}]'
spec:
  {{- if not .Values.autoscaling.enabled }}
  replicas: {{ .Values.replicaCount }}
  {{- end }}
  selector:
    matchLabels:
      {{- include "bbbAtScaleWebhooksWorker.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      {{- with .Values.podAnnotations }}
      annotations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      labels:
        {{- include "bbbAtScaleWebhooksWorker.selectorLabels" . | nindent 8 }}
    spec:
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "bbbAtScale.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      volumes:
      - configMap:
          defaultMode: 420
          name: {{ include "bbbAtScale.fullname" . }}-files
        name: config
      containers:
        - name: {{ .Chart.Name }}
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.image.repository }}:{{ .Values.image.tag | default .Chart.AppVersion }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          volumeMounts:
            {{- if .Values.bbbAtScale.configmapfiles.create -}}
            {{- toYaml .Values.bbbAtScale.volumeMounts | nindent 12 }}
            {{- end }}
          command:
            - bbbatscale
            - webhooks-worker
          envFrom:
            - configMapRef:
                name: {{ include "bbbAtScale.fullname" . }}
          env:
            - name: POSTGRES_DB
              value: {{ .Values.postgresql.postgresqlDatabase }}
            - name: POSTGRES_USER
              value: {{ .Values.postgresql.postgresqlUsername }}
            - name: POSTGRES_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: {{ .Release.Name }}-postgresql
                  key: postgresql-password
            - name: POSTGRES_HOST
              value: {{ .Release.Name }}-postgresql
            - name: DJANGO_SECRET_KEY
              valueFrom:
                secretKeyRef:
                  name: {{ include "bbbAtScale.fullname" . }}
                  key: DJANGO_SECRET_KEY
            - name: RECORDINGS_SECRET
              valueFrom:
                secretKeyRef:
                  name: {{ include "bbbAtScale.fullname" . }}
                  key: RECORDINGS_SECRET
            - name: LDAP_BINDDN
              valueFrom:
                secretKeyRef:
                  name: {{ include "bbbAtScale.fullname" . }}
                  key: LDAP_BINDDN
            - name: LDAP_BINDPASS
              valueFrom:
                secretKeyRef:
                  name: {{ include "bbbAtScale.fullname" . }}
                  key: LDAP_BINDPASS
            - name: REDIS_HOST
              value: {{ .Release.Name }}-redis-master
            - name: REDIS_PORT
              value: {{ .Values.redis.redisPort | quote }}
            - name: REDIS_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: {{ .Release.Name }}-redis
                  key: redis-password
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
